/*		EM2			*/
void EM()
{
   int M = 100, Mbs = 50, M_old = 100, m = 0, convergence = 0;
   double sf = 1.0, sm = 1.0, sf_old, sm_old; 
   double bf[N], bm[N];
   double *Bf[N], *Bm[N], *Bf_old[N], *Bm_old[N];
   double alpha[4], alpha_old[4];
   double maxdiff ;
   long time1;
   int l,i,j,g,k;

   void Estep(long *t, double alpha[], double sf, double sm, int MC, int m, 
              double *Bf[], double *Bm[], double bf[], double bm[]);
   void Monitor_likelihood(double alpha[], double vf, double vm, 
        double alpha_old[], double vf_old, double vm_old, int MC, 
        int M_old, double *Bf[], double *Bm[], double *Bf_old[], double *Bm_old[]);
   void Mstep(int i, double *Bf[], double *Bm[], double alpha[], 
              double *psf, double *psm, int M);
   void Update(int i, int *m, int *M, int *Mbs, double maxdiff, int *conv);
   double maximum(double a[], double a_old[], double sf, double sf_old, double
                    sm, double sm_old);

   for (j = 0; j < N; ++j)
   {
      Bf[j] = malloc(Mmax*sizeof(double));
      Bm[j] = malloc(Mmax*sizeof(double));
/*
      Bf_old[j] = malloc(Mmax*sizeof(double));
      Bm_old[j] = malloc(Mmax*sizeof(double));
*/
   }
   time1 = -1431;
   for(j = 0; j < N; ++j)			
      bf[j] = bm[j] = 0;
   for(g = 0; g < 4; g++)				
	  alpha[g] = 0;

   for(i=1;i <= 120; ++i)              
   {

       printf("\nStep  %d    M = %d\n", i,M);

       Estep(&time1, alpha, sf, sm, M, m, Bf, Bm, bf, bm);
/*
       if(i > 1)
       Monitor_likelihood(alpha, sf*sf, sm*sm, alpha_old, 
          sf_old*sf_old, sm_old*sm_old, 
          M+Mbs, M_old, Bf, Bm, Bf_old, Bm_old);
*/


       sf_old = sf; sm_old = sm;		
       for(g = 0; g < 4; ++g)  
          alpha_old[g] = alpha[g]; 
/*       for(j = 0; j < N; j++)			
       {
          for(l = 0; l < Mbs; l++)			
          {  
              Bf_old[j][l] = (Bf[j][M+l]);
              Bm_old[j][l] = (Bm[j][M+l]);
          }
       }
   	   M_old = Mbs;
*/

       Mstep(i, Bf, Bm, alpha, &sf, &sm, M);
       maxdiff = maximum(alpha,alpha_old,sf,sf_old,sm,sm_old);
       Update(i, &m, &M, &Mbs, maxdiff, &convergence);
   } 
}


		/* Functions' definitions	*/

double maximum(double a[], double a_old[], double vf, double vf_old, double
   vm, double vm_old)
{
   double y, u;
   int g;

   y = fabs(a[0] - a_old[0]);
   for (g = 1; g < 4; ++g)
   {
      u = fabs(a[g] - a_old[g]);
      y = (u > y) ? u : y;
   }
   u = fabs((vf-vf_old)/vf); 
   y = (u > y) ? u : y;
   u = fabs((vm-vm_old)/vm); 
   y = (u > y) ? u : y;
   return y;
} 

double max(double a[], double sf, double sm)
{
  double y, u;
  int g;

  y = fabs(a[0]);
  for(g = 1; g < 4; ++g)
  {
	y = (fabs(a[g]) > y) ? fabs(a[g]) : y;
  }
  y = (fabs(sf) > y) ? fabs(sf) : y;
  y = (fabs(sm) > y) ? fabs(sm) : y;
  return(y);
}

double clr(double bf[], double bm[], double a1[], double vf1, double vm1, 
  double a2[], double vf2, double vm2)
{
  int g, k, l, j;
  double A, B, sf=0, sm=0;
  double bs(double l1[], double l2[], int M1, int M2, 
         double x1[], double x2[]);
  double bs1(double l1[], double l2[], int M1, int M2, 
        double x1[], double x2[]);

  A = 0;
  for (g = 0; g < 4; g++)
  {
	A += ybar[g]*nmix*(a1[g]-a2[g]);
  }
  for (k=0; k < SSIZE; ++k)
  {
     A+= - log(1+exp(a1[mix[k]]+bf[female[k]]+bm[male[k]])) 
	     + log(1+exp(a2[mix[k]]+bf[female[k]]+bm[male[k]])) ;
  }

  for (j = 0; j < N; ++j)
  {
	sf += pow(bf[j],2);
	sm += pow(bm[j],2);
  } 
  B = -1/2*( N*log(vf1/vf2*vm1/vm2) + (1/vf1 - 1/vf2)*sf + 
			 (1/vm1 - 1/vm2)*sm );
  return (exp(A+B));	
}

/*
double bs(double l1[], double l2[], int M1, int M2)
{
  int Iter=2;
  double r=1;
  int l, i;
  double s1, s2, A, B;

  s1 = (double)M1/(M1+M2); s2 = (double)M2/(M1+M2);
  for (i = 0; i < Iter; i++)
  {
	A = 0;
	for (l =0; l < M2; l++)
	  A += l2[l]/(s1*l2[l] + s2*r);
    A = A/M2;
	B = 0;
	for (l = 0; l < M1; l++)
	  B += 1/(s1*l1[l] + s2*r);
    B = B/M1;
	r = A/B;
  }
  return log(r);
}    
*/


double bs(double l1[], double l2[], int M1, int M2, 
          double x1[], double x2[])
{
  double mean(double x[], int M);
  int l, i, Iter=2;
  double s1, s2, r=1;
   
  s1 = (double)M1/(M1+M2); s2 = (double)M2/(M1+M2);
  for(i = 0; i < Iter; i++)
  {
    for(l = 0; l < M2; l++)
       x2[l] = l2[l]/(s1*l2[l] + s2*r);
    for(l = 0; l < M1; l++)
       x1[l] = 1/(s1*l1[l] + s2*r);
    r = mean(x2, M2)/mean(x1, M1);
  }
  return log(r) ;
}
  

/*
double bs1(double l1[], double l2[], int M1, int M2)
{
  int l;
  double A, B;
  A = 0;
  for (l =0; l < M2; l++)
    A += sqrt(l2[l]);
  A = A/M2;
  B = 0;
  for (l = 0; l < M1; l++)
    B += 1/sqrt(l1[l]);
  B = B/M1;
  return log(A/B);
}
*/

double bs1(double l1[], double l2[], int M1, int M2, 
          double x1[], double x2[])
{
  double mean(double x[], int M);
  int l;
  for(l = 0; l < M2; l++)
	 x2[l] = sqrt(l2[l]);
  for(l = 0; l < M1; l++)
	 x1[l] = 1/sqrt(l1[l]);
  return log(mean(x2, M2)/mean(x1, M1));
}

double mean(double x[], int M)
{
  double A = 0; int l;

  for(l = 0; l < M; l++)
	A += x[l];
  return A/M;
}

double autocov(int k, double x[], int M)
{
  double sxy = 0, sx = 0; int i;

  for(i = 0; i < M; i++)
    sx += x[i];
  for(i = 0; i < M-k; i++)
	sxy += x[i]*x[i+k];
  return  (double) sxy/(M-k) - (double) sx*sx/(M*M);
}

double varbatch(double x[], int M)
{
  double syy = 0, sy = 0, sx; int i,j;
  int R = 40, n;

  n = M/R;
  for(i = 0; i < R; i++)
  { 
	sx = 0;
	for(j = 0; j < n; j++)
	   sx += x[i*n+j];
    sy += sx;
    syy += sx*sx;		
  }
  return  (syy - sy*sy/R)/(n*(R-1));
}

double imsv(double x[], int M)
{  
   double autocov(int k, double x[], int M);
   double v, Gamma, G;
   int k, i; 
   v = -autocov(0,x,M);
   Gamma = -v + autocov(1,x,M);  
   k = 1;
   do{
      G = Gamma;
      v  += 2*Gamma;
	  Gamma = autocov(2*k,x,M) + autocov(2*k+1,x,M);
	  k++;
   } while ( (Gamma < G) && (Gamma > 0) );
   return v;
}

     
 


double var(double x[], int M)
{
  double sxx = 0, sx = 0;
  int i;
  for(i = 0; i <M; i++)
  {
	sxx += x[i]*x[i];
	sx += x[i];
  }
  return  (double) (sxx - sx*sx/M)/(M-1);
}

void Estep(long *t, double alpha[], double sf, double sm, int MC, int m,
		   double *Bf[], double *Bm[], double bf[], double bm[])
{  
   /*  creates MC draws from (bf,bm) | alpha,sf,sm	*/  
   /*  to be stored in Bf,Bm						*/
   /*  m = burnout; *t = random seed				*/
  
   int j,k,l;
   double bound, eta, u, v[SSIZE]; 
   double lowerf[N], lowerm[N], upperf[N], upperm[N]; 

/*   *t = 100;  */
   for (l = 0; l < MC+m; ++l)     /* MC for E step        */
   {
      for ( k= 0; k < SSIZE; ++k)    /* generate logistic var */
      {
         eta = exp(alpha[mix[k]] + sf*bf[female[k]] + sm*bm[male[k]]);
         if (y[k] == 1)
         {
            u = ran1(t) * eta/(1 + eta);
            v[k] = log(u/(1 - u));
         }
         else
         {
            u = ran1(t) / (1 + eta);
            v[k] = log((1-u)/u);
         }
      }

      for (j = 0; j < N; ++j)        /* init-ize bounds      */
      {
         lowerf[j] = -LM;
         lowerm[j] = -LM;
         upperf[j] = LM;
         upperm[j] = LM;
      }
      for (k = 0; k < SSIZE; ++k)    /* female bounds        */
      {
         bound = (v[k] - alpha[mix[k]] - sm*bm[male[k]])/sf;
         if (y[k] == 1)
            lowerf[female[k]]=(bound > lowerf[female[k]]) ?
                               bound : lowerf[female[k]];
         else
            upperf[female[k]]=(bound < upperf[female[k]]) ?
                              bound : upperf[female[k]];
       }

       for (j = 0; j < N; ++j)       /* female rand effects  */
       {
         bf[j]= r_tr_normal(t, lowerf[j], upperf[j]);
       }

       for (k = 0; k < SSIZE; ++k)   /* male bounds          */
       {
          bound = (v[k] - alpha[mix[k]] - sf*bf[female[k]])/sm;
          if (y[k] == 1)
             lowerm[male[k]]=(bound > lowerm[male[k]]) ?
                                bound : lowerm[male[k]];
          else
             upperm[male[k]]=(bound < upperm[male[k]]) ?
                               bound : upperm[male[k]];
       }

       for (j = 0; j < N; ++j)       /* male rand effects    */
       {
         bm[j]= r_tr_normal(t, lowerm[j], upperm[j]);
       }


       if (l >= m)
       {
          for (j = 0; j < N; ++j)
          {
             Bf[j][l-m] = bf[j];
             Bm[j][l-m] = bm[j];
          }
       }
    }     

}



void Monitor_likelihood(double alpha[], double vf, double vm,
   double alpha_old[], double vf_old, double vm_old, int MC, 
   int M_old, double *Bf[], double *Bm[], double *Bf_old[], double *Bm_old[])
{
  double clr(double bf[], double bm[], double a1[], double vf1, double vm1, 
         double a2[], double vf2, double vm2);
  double bs(double l1[], double l2[], int M1, int M2, 
         double x1[], double x2[]);
  double bs1(double l1[], double l2[], int M1, int M2, 
        double x1[], double x2[]);
  double varbatch(double x[], int M);
  double var(double x[], int M);
  double autocov(int k, double x[], int M);
  double imsv(double x[], int M);

  int l,j;
  double bf[N], bm[N], bfo[N], bmo[N], l_old[Mmax], l_new[Mmax],
      x_old[Mmax], x_new[Mmax];
  double logr, lb, ub, v1, v2, g01, g02, var_bs, rho1, rho2; 
  double vfc, vmc; 

  printf(" log LR (SD): \n"); 
  for(l = 0; l < MC; l++)           /* lik ratios, l1 & l2  */
  {
      for(j = 0; j < N; j++)
      {
         bf[j] = Bf[j][l]; bm[j] = Bm[j][l];
      }
      l_new[l] = clr(bf,bm,alpha,vf,vm,alpha_old,vf_old,vm_old);
   }
   
   for(l = 0; l < M_old; l++)
   {
      for(j=0; j < N; j++)
      {
         bfo[j] = Bf_old[j][l]; bmo[j] = Bm_old[j][l];
      }
      l_old[l] = clr(bfo,bmo,alpha,vf,vm,alpha_old,vf_old,vm_old);
   }

   logr = bs1(l_new,l_old,MC,M_old,x_new,x_old); /* bridge sampling estimate */

   rho1 = autocov(1, l_new, MC)/var(l_new, MC);
   rho2 = autocov(1, l_old, M_old)/var(l_old, M_old);
   g01 = var(x_new, MC)/MC;
   g02 = var(x_old, M_old)/M_old;
   v1 = g01*(1+rho1)/(1-rho1);
   v2 = g02*(1+rho2)/(1-rho2);
   var_bs = (v1 + pow(exp(logr),2)*v2)/pow(mean(x_old, M_old),2);
   printf("                  %.4lf  (%.4lf)\n", logr, sqrt(var_bs));
   printf(" mean x_old  %.4lf  \n", mean(x_old, M_old));

   printf(" Var inflation factors:\n");
/*
   v1 = imsv(x_new, MC)/MC; 
   v2 = imsv(x_old, M_old)/M_old; 
   printf("       IMSV      %.4lf,  %.4lf\n", v1/g01, v2/g02);
   v1 = varbatch(x_new, MC)/MC;
   v2 = varbatch(x_old, M_old)/M_old;
   printf("       Batch     %.4lf,  %.4lf\n", v1/g01, v2/g02);
*/
   printf("       AR1       %.4lf,  %.4lf\n", (1+rho1)/(1-rho1), 
			(1+rho2)/(1-rho2));
   printf("  Stdev:      %.4lf,  %.4lf\n", sqrt(v1),sqrt(v2)); 
   printf("  Autocor:    %.4lf,  %.4lf\n", rho1,rho2); 
   printf("  S :         %.4lf,  %.4lf\n", sqrt(var(x_new,MC)),
              sqrt(var(x_old, M_old))); 
   printf("  Sampl sz:   %5d,  %5d\n", MC,M_old); 
}


void Mstep(int i, double *Bf[], double *Bm[], double alpha[],  
           double *psf, double *psm, int M)
{
   /* updates alpha, vf, vm based on the draws in Bf, Bm	*/

   int g,k,l,j;
   double eta, pi, w, sf, sm, delta[4], d[4], df[4], dm[4], csi[4];
   double dff, dfm, dmm, csif, csim, deltaf, deltam, bff, bmm;
   int NRcount, flag;
   double max(double a[], double sf, double sm);

   sf = *psf; sm = *psm;
   for(g = 0; g < 4; ++g)
      delta[g] = epsNR*2;
   NRcount = 0;
   do{				/* NR cycle	*/
      for(g = 0; g < 4; ++g)
         d[g] = df[g] = dm[g] = csi[g] = 0;
	  dff = dfm = dmm = csif = csim  = 0;

      for(l = 0; l < M; ++l)
      {
         for (k = 0; k < SSIZE; ++k)     
         {
                bff = Bf[female[k]][l];
                bmm = Bm[male[k]][l];
                eta = alpha[mix[k]]+ sf*bff + sm*bmm;
                pi = exp(eta)/(1+exp(eta));
				w = pi*(1-pi);
				d[mix[k]] += w;
                df[mix[k]] += w*bff;
                dm[mix[k]] += w*bmm;
				dff += w * bff * bff;
				dfm += w * bff * bmm;
				dmm += w * bmm * bmm;
				csi[mix[k]] += w*eta + (y[k] - pi);
				csif += bff * (w*eta +(y[k] - pi));
				csim += bmm *(w*eta + (y[k] - pi));
          }
       }

	   for(g  = 0; g < 4; ++g)
	   {
		  dff += -df[g] * df[g] / d[g];
		  dfm += -df[g] * dm[g] / d[g];
		  dmm += -dm[g] * dm[g] / d[g];
		  csif += -df[g] * csi[g] / d[g];
		  csim += -dm[g] * csi[g] / d[g];
       }

	   deltaf = (csif*dmm - csim*dfm)/(dff*dmm - dfm*dfm);
	   deltam = (dff*csim - dfm*csif)/(dff*dmm - dfm*dfm);
	   for(g = 0; g < 4; ++g)
          delta[g] = (csi[g] - sf*df[g] - sm*dm[g]) / d[g];
       
       deltaf += - sf; deltam += - sm;
       sf += deltaf; sm += deltam;
       for(g = 0; g < 4; ++g)
       {
          delta[g] += -alpha[g];
          alpha[g] += delta[g]; 
       }
       NRcount++;

    } while(max(delta, deltaf, deltam) > epsNR);
   
/*
      for(g = 0; g < 4; ++g)		
         csi[g] = 0;
	  csif = csim  = 0;

      for(l = 0; l < M; ++l)
      {
         for (k = 0; k < SSIZE; ++k)     
         {
                eta = alpha[mix[k]]+ sf*Bf[female[k]][l] +
                    sm*Bm[male[k]][l];
                pi = exp(eta)/(1+exp(eta));
                csi[mix[k]] += (y[k] - pi);
                csif += Bf[female[k]][l] * (y[k] - pi);
                csim += Bm[male[k]][l] * (y[k] - pi);
          }
       }
       printf(" Score function: %.4f, %.4f, %.4f, %.4f, %.4f, %.4f\n",
              csi[0], csi[1], csi[2], csi[3], csif, csim);

*/
    *psf = sf; *psm = sm;

    printf("      NR iter%2d\n",NRcount);
    printf(" Y %d   %.4lf %.4lf %.4lf %.4lf  ",
             M, alpha[0],alpha[1],alpha[2],alpha[3]);
    printf("  %.4lf   %.4lf\n",sf, sm);
}


void Update(int i, int *m, int *M, int *Mbs, double maxdiff, int *conv)
{
  if (maxdiff < eps)
            ++(*conv);
       else if (*conv >= 1)
          *conv = 0;
       printf("      maximum difference %.4lf\n",maxdiff);
       if ( *conv >= 1)
          printf("   conv  %d\n", *conv);



       {
         if ( i < 50)
            *M = 100;
         else if ( i < 70 )
			*M = (i-49)*500;
         else if ( i < 200 )
			*M = 10000;
        }

/*
        if (*conv > 0)
        {
          *M = 1.5*(*M);
        }
      *Mbs = (*M)/2;
*/
      *Mbs = 0;
      *m = 100;
}
